#!/bin/bash
#
# bash-common-api:message-api.sh
#

#
# Handle colors
#
declare -r BLUE='\033[0;34m'
declare -r CYAN='\033[0;36m'
declare -r GREEN='\033[0;32m'
declare -r MAGENTA='\033[0;35m'
declare -r RED='\033[0;31m'
declare -r YELLOW='\033[0;33m'

declare -r LIGHT_BLUE='\033[1;34m'
declare -r LIGHT_CYAN='\033[1;36m'
declare -r LIGHT_GREEN='\033[1;32m'
declare -r LIGHT_MAGENTA='\033[1;35m'
declare -r LIGHT_RED='\033[1;31m'
declare -r LIGHT_YELLOW='\033[1;33m'

declare -r NOCOLOR='\033[0m' # No Color

function test_colors { # Just to avoid shellcheck warnings.
  echo -e "${BLUE}BLUE ${CYAN}CYAN ${GREEN}GREEN ${MAGENTA}MAGENTA ${RED}RED ${YELLOW}YELLOW${NOCOLOR}"
  echo -e "${LIGHT_BLUE}LIGHT_BLUE ${LIGHT_CYAN}LIGHT_CYAN ${LIGHT_GREEN}LIGHT_GREEN ${LIGHT_MAGENTA}LIGHT_MAGENTA ${LIGHT_RED}LIGHT_RED ${LIGHT_YELLOW}LIGHT_YELLOW${NOCOLOR}"
}

# Use stderr (&2) for all outputs
function echofatal {
  echo -en "*** [${LIGHT_RED}FATAL${NOCOLOR}] $( date ) - ${LIGHT_RED}" >&2
  cat  >&2 <<EOF
$@
EOF
   echo -en "${NOCOLOR}" >&2
}

# Use stderr (&2) for all outputs
function echoerror {
  echo -en "*** [${RED}ERROR${NOCOLOR}] $( date ) - ${LIGHT_RED}" >&2
  cat  >&2 <<EOF
$@
EOF
   echo -en "${NOCOLOR}" >&2
}

# Use stderr (&2) for all outputs
function echowarn {
  echo -en "*** [${CYAN}WARN${NOCOLOR}] $( date ) - ${CYAN}" >&2
  cat  >&2 <<EOF
$@
EOF
   echo -en "${NOCOLOR}" >&2
}

# Use stdout (&1) for all outputs
function echoinfo {
  echo -en "* [${LIGHT_YELLOW}INFO${NOCOLOR}] $( date ) - ${LIGHT_YELLOW}"
  cat <<EOF
$@
EOF
   echo -en "${NOCOLOR}"
}

# Use stdout (&1) for all outputs
function echookay {
  echo -en "* [${LIGHT_GREEN}OK${NOCOLOR}] $( date ) - ${LIGHT_GREEN}"
  cat <<EOF
$@
EOF
   echo -en "${NOCOLOR}"
}

